Bug 51621 - Missing jars in Deployer
Missing jars in Deployer
Product: Tomcat 7
Classification: Unclassified
Component: Packaging
HP All
: P2 normal (vote)
: ---
Assigned To: Tomcat Developers Mailing List
Depends on:
  Show dependency tree
Reported: 2011-08-05 10:33 UTC by Silvio Corciolani
Modified: 2012-01-18 09:31 UTC (History)
1 user (show)


Note You need to log in before you can comment on or make changes to this bug.
Description Silvio Corciolani 2011-08-05 10:33:26 UTC
I put to ANT classpath all jars included in "apache-tomcat-7.0.19-deployer.zip" ("lib" dir).
Trying to run the Deployer ANT task "undeploy", I got:

java.lang.NoClassDefFoundError: org/apache/tomcat/util/buf/B2CConverter

I added to ANT classpath "tomcat-coyote.jar" from Tomcat core distribution (apache-tomcat-7.0.19-windows-x64.zip), and I got:

java.lang.NoClassDefFoundError: org/apache/tomcat/util/res/StringManager

I added to ANT classpath "tomcat-util.jar" from Tomcat core distribution (apache-tomcat-7.0.19-windows-x64.zip), and finally I got the task successfully executed.

Therefore, I guess the Deployer distribution should include "tomcat-coyote.jar" and "tomcat-util.jar".
Comment 1 Mark Thomas 2011-08-05 18:09:18 UTC
Thanks for the report. This has been fixed in 7.0.x and will be included in 7.0.20 onwards.
Comment 2 Paul 2012-01-17 05:10:43 UTC
Either this is not fixed, or I don't understand what the fix was (because it's not listed).  I'm still getting this exception with 7.0.22.

When using a catalina-ant.jar from 2008 (I don't know which version of Tomcat it came from - the manifest.mf file is dated 2008-07-22) I don't need to include the extra jars as described in this thread:


Perhaps a slightly better stack trace would be helpful:

java.lang.NoClassDefFoundError: org/apache/tomcat/util/buf/B2CConverter
  at org.apache.catalina.util.Base64.encode(Base64.java:177)
  at org.apache.catalina.ant.AbstractCatalinaTask.execute(AbstractCatalinaTask.java:204)
  at org.apache.catalina.ant.DeployTask.execute(DeployTask.java:211)
  at org.apache.tools.ant.UnknownElement.execute(UnknownElement.java:291)
Comment 3 Mark Thomas 2012-01-18 09:31:08 UTC
This issue is fixed. If you need further assistance, the users list is the place to ask. Bugzilla is not a support forum.